from AccessControl import ClassSecurityInfo
from OFS.SimpleItem import SimpleItem
from OFS.PropertyManager import PropertyManager
from Products.CMFCore.utils import UniqueObject 
from Globals import InitializeClass

from sql.Sql99 import sqlClasses
from Permissions import RakunAccessDatabase,ManagePortal
from Settings import DatabaseToolName, DatabaseToolMetaType

class DatabaseTool(UniqueObject, SimpleItem, PropertyManager):
    """
       Database Tool 
    """
    
    id = DatabaseToolName
    meta_type = DatabaseToolMetaType
    toolicon = 'zmi/dbtool.gif'
    security = ClassSecurityInfo()
    
    manage_options = (PropertyManager.manage_options
                     + SimpleItem.manage_options
                     )
    
    security.declareProtected(RakunAccessDatabase,"getSqlClasses")
    def getSqlClasses(self):
        return sqlClasses.keys()
    
    security.declareProtected(RakunAccessDatabase,"getDBObject")
    def getDBObject(self,sqlserverfamily,connectionid):
        connection = getattr(self,connectionid)
        dbobject = sqlClasses[sqlserverfamily]
        return dbobject(connection)
    
    
 
    
InitializeClass(DatabaseTool)    

    