"""Exception Classes for Rakun"""

# These classes are placed here so that they can be imported into TTW Python
# scripts. To do so, add the following line to your Py script:
# from Products.Rakun.Errors import ValidationError ....

from Products.PythonScripts.Utility import allow_class
from Products.Formulator.Errors import ValidationError
allow_class(ValidationError)

class RakunError(Exception):
    error_type = 'RakunError'
    def __init__(self, value):
        self.value = value
        
    def __str__(self):
        return str(self.value)
    
    
class RakunInsertError(RakunError):
    error_type = 'RakunInsertError'
    
allow_class(RakunInsertError)

class RakunUpdateError(RakunError):
    error_type = 'RakunUpdateError'
    
allow_class(RakunUpdateError)

class RakunDeleteError(RakunError):
    error_type = 'RakunDeleteError'
    
allow_class(RakunDeleteError)

class RakunValidationError(RakunError):
    error_type = 'RakunValidationError'
    
allow_class(RakunValidationError)

