from Products.Formulator.DummyField import fields

class GRIDProperties:
    """Field GRID Properties
    """
    
    property_names = ['issearchable','grid_hidden','summary']
    
    issearchable = fields.CheckBoxField('issearchable',
                                        title='Searchable',
                                        default=False,
                                        required=0)
    
    grid_hidden = fields.CheckBoxField('grid_hidden',
                                       title='Hidden',
                                       default=False,
                                       required=0)
    summary = fields.CheckBoxField('summary',
                                   title='Summary',
                                   default=False,
                                   required=0)
    

FieldGRIDPropertiesInstance = GRIDProperties()

class FORMProperties:
    """Field FORM Properties
    """
    
    property_names = ['helperapp','relationcond']
    
    helperapp = fields.StringField('helperapp',
                                   title='Helper Application',
                                   required=0)
    
    relationcond = fields.StringField('relationcond',
                                      title='Relation Condition',
                                      required=0)

FieldFORMPropertiesInstance = FORMProperties()


class DBProperties:
    """Field Database Properties
    """

    property_names = ['name', 'type', 'isautoincrement', 'insert', 'update']

    name = fields.StringField('name',
                              title='Column Name',
                              required=0)

    type = fields.ListField('type',
                            title='Type',
                            items=[('String', 'string'),
                                   ('Text','text'),
                                   ('Boolean', 'boolean'),
                                   ('Integer', 'integer'),
                                   ('Float','float'),
                                   ('Date','date'),
                                   ('Money','money'),
                                   ('File','file')],
                            required=1,
                            size=1,
                            default='string')
    
    isunique = fields.CheckBoxField('isunique',
                                    title='Is Unique',
                                    default=0,
                                    required=0)
    

    isforeign = fields.CheckBoxField('isforeign',
                                    title='Is Foreign Field',
                                    default=0,
                                    required=0)
    
    
    isautoincrement = fields.CheckBoxField('isautoincrement',
                                    title='Is Auto Increment',
                                    default=0,
                                    required=0)
    
    insert = fields.CheckBoxField('insert',
                                  title='Insert Allowed',
                                  default=1,
                                  required=0)
    
    update = fields.CheckBoxField('update',
                                  title='Update Allowed',
                                  default=1,
                                  required=0)
    
FieldDBPropertiesInstance = DBProperties()    