# -*- coding: utf-8 -*-
from Interface import Interface


class ISql(Interface):     
        

    def render_sql_value(self, dbobject, value):
        """
        insert ve update işlemlerinde eşitliğin sağında
        koşul ifadelerinde operatorun sağında
        """
    
    def render_sql_insert_field(self):
        """
        insert işlemindeki alan adı
        """
    
    def render_sql_update_field(self):
        """
        update işlemindeki alan adı
        """
    
    def render_sql_field(self):
        """
        select ifadesindeki alan adı
        """

    def render_sql_function(self):
        """
        sql ifadesinde fonksiyon içine girecek ifade için
        """
        
    def get_sql_field_name(self):
        """
        select işleminden sonra veritabanından dönecek alan adı
        """
    
    def get_sql_field_alias(self):
        """
        select işleminden sonra zope'ta beklenen ad
        """
    def get_db_type(self):
        """
        veritabanı tipi
        """
        
    def render_sql_table(self):
        """
        select işlemi için tablo adı
        """
    
    def get_sql_join_condition(self):
        """
        relation nesnesi kullanıldığında join koşulu
        """
    
    def render_sql_condition(self):
        """
        koşul ifadelerinde operatorun solunda 
        """
    
    def render_sql_groupby(self):
        """
        select ifadesinde gruplama içinde kullanılacak alan adları
        """

    def render_sql_orderby(self):
        """
        sıralama için kullanılacak alanlar
        """
    


class IRpc(Interface):  
    

    def dump(self, marshaller, write):
        """
        XML-RPC Server nesneyi dışarıya gönderirken
        """
        
    def load(self, obj):
        """
        XML-RPC Server dışardan nesneyi aldığında
        """
    


class IXml(Interface):
    pass
