from thread import get_ident
from ZPublisher import Publish, mapply
from ZPublisher.Publish import get_module_info


def get_request():
    """Get a request object"""    
    return Publish._requests.get(get_ident(), None)
   
def publish_patch(request, module_name, after_list, debug=0):      
    request.set('MODULE_NAME', module_name)
    Publish._requests[get_ident()] = request    
    response = Publish.orig_publish(request, module_name, after_list, debug)
    try:
        del Publish._requests[get_ident()]
    except KeyError:
        # already deleted?
        pass

    return response

def applyRequestPatch():
    if not hasattr(Publish, 'orig_publish'):        
        # Apply patch
        Publish._requests = {}
        Publish.orig_publish = Publish.publish
        Publish.publish = publish_patch        

applyRequestPatch()



def get_zope_object(path='/'):    
    request = get_request()
    if request.has_key('ZOPE_ROOT'):
        root = request.get('ZOPE_ROOT')
    else:
        
        module_name = request.get('MODULE_NAME')
    
        (bobo_before, bobo_after, object, realm, debug_mode, err_hook,
         validated_hook, transactions_manager)= get_module_info(module_name)
    
        request['PARENTS']=[object]
        URL = request['URL']
        root = request.traverse('/', validated_hook=validated_hook)  
        request['URL'] = URL
        request.set('ZOPE_ROOT', root)
    
    #return root.restrictedTraverse(path)
    if path=="/":
        return root
    else:
        return eval("root"+path.replace("/","."))

import __builtin__
__builtin__.get_zope_object = get_zope_object
del __builtin__
    
#-------------------------------------------------------------------------------
# zrdb results patch    
def dictionaries(self):
  r=[]
  a=r.append
  names=self.names()
  real_names = getattr(self,'real_names',{})
  for row in self:
    d={}
    for n in names: d[real_names.get(n,n)]=row[n]
    a(d)
  return r

from Shared.DC.ZRDB.Results import Results
Results.dictionaries = dictionaries

#-------------------------------------------------------------------------------
# xml-rpc datetime patch    
from xmlrpclib import Marshaller, Unmarshaller
from DateTime import DateTime
from IObjects import IRpc

def __dump(self, value, write):
    """rakun dump patch"""
    try:
        f = self.dispatch[type(value)] 
    except KeyError:
        if IRpc.isImplementedBy(value):
            value.dump(self, write)
        else:
            raise TypeError, "cannot marshal %s objects" % type(value)
    else:
        f(self, value, write)           

Marshaller._Marshaller__dump = __dump

from types import DictType
from Settings import RakunClasses

def convertToPythonObject(xmlobj):
    if type(xmlobj) == DictType and xmlobj.has_key('__class__'):
        if xmlobj.has_key('path'):
            return get_zope_object(xmlobj.get('path'))
        else:
            constructor = RakunClasses.get(xmlobj.get('__class__'))
            args = xmlobj.get('args')
            return constructor(*args)
    else:
        return xmlobj            
 
def end_struct(self, data):
    self.end_struct(data)
    self._stack[-1] = convertToPythonObject(self._stack[-1])         

Unmarshaller.dispatch['struct'] = end_struct
        
        
DateTimeType = type(DateTime())
def dump_DateTime(self, value, write):
  value = DateTime(str(value)).ISO()
  self.dump_string(value,write)
  
Marshaller.dispatch[DateTimeType] = dump_DateTime


#-----------backward compatibility for 'Rakun Interface' -----------------------
from Zope.App import ClassFactory

def newClassFactory(jar, module, name, _silly=('__doc__',), _globals={},):
    """ """
    if module == 'Products.Rakun.Interface':
        module = 'Products.Rakun.Module'
    return ClassFactory.ClassFactory_orig(jar, module, name, _silly, _globals)


def patchClassFactory():
    if not hasattr(ClassFactory,'ClassFactory_orig'):
        ClassFactory.ClassFactory_orig = ClassFactory.ClassFactory
        ClassFactory.ClassFactory = newClassFactory

patchClassFactory()    