from Products.PageTemplates.GlobalTranslationService import \
     getGlobalTranslationService, DummyTranslationService

service = None
translate = None

def get_i18n_language(context,domain):
    request = context.REQUEST
    language = request.get('TARGET_LANGUAGE',None)    
    if not language:
        ts = getGlobalTranslationService()
        language = ts.negotiate_language(context,domain)
        request.set('TARGET_LANGUAGE',language)
    return language   

def translate_wrapper(domain, msgid, mapping=None, context=None,
                      target_language=None, default=None,as_unicode=0):
    # wrapper for calling the translate() method with a fallback value
    if service == None:
        initialize()
    if not target_language and context:
        target_language = get_i18n_language(context, domain)
    if not default:
        default = msgid
    if as_unicode:
        service_translate = service.utranslate
    else:
        service_translate = service.translate
    try:
        res = service_translate(domain, msgid, mapping=mapping,
                                context=context,
                                target_language=target_language,
                                default=default)
    except TypeError:
        #Localizer does not take a default param
        res = service_translate(domain, msgid, mapping=mapping,
                                context=context,
                                target_language=target_language)

    if res is None or res is msgid:
        return default
    return res

def null_translate(domain, msgid, mapping=None, context=None,
                   target_language=None, default=None):
    return default

def initialize():
    # IMPORTANT: this module is unusable before this is called
    # this must be so because we want to make sure all products
    # (eg, whatever translation service we're supposed to use)
    # is already there and ready
    global service, translate
    service = getGlobalTranslationService()
    if service is DummyTranslationService:
        translate = null_translate
    elif hasattr(service, '_fallbacks'):
        # it accepts the "default" argument
        translate = service.translate
    else:
        translate = translate_wrapper

def initial_translate(domain, msgid, mapping=None, context=None,
                      target_language=None, default=None,as_unicode=0):
    initialize()
    return translate(domain, msgid, mapping, context, target_language, default,as_unicode)

translate = initial_translate


class IndexIterator:
    __allow_access_to_unprotected_subobjects__ = 1

    def __init__(self, upper=100000, pos=0):
        self.upper = upper
        self.pos = pos

    def next(self):
        if self.pos <= self.upper:
            self.pos += 1
            return self.pos
        raise KeyError, 'Reached upper bounds'
