import sys, os
from AccessControl import allow_module, allow_class, allow_type,ModuleSecurityInfo
from Products.CMFCore.DirectoryView import registerDirectory 
from Products.CMFCore import utils
from Products.CMFCore import DirectoryView
from Products.CMFPlone.utils import ToolInit
from Module import Interface, manage_addInterface, manage_addInterfaceForm
from Entity import Entity, manage_addEntity, manage_addEntityForm

from FieldsRegistry import registerFields, initializeFields

from DatabaseTool import DatabaseTool 
from ApplicationTool import ApplicationTool
from Settings import ApplicationToolName
import Patch
import sql, Permissions, Errors
from RakunUtils import IndexIterator
allow_class(IndexIterator)

from StringIO import StringIO
allow_class(StringIO)

from RequestManagement import RequestForm
allow_class(RequestForm)

ModuleSecurityInfo('Products.Rakun.RakunUtils').declarePublic('translate_wrapper')
allow_module('Products.Rakun.RakunUtils')



# Rakun Menu initialize
from MenuTool import MenuSeparator, manage_addMenuSeparator, manage_addMenuSeparatorForm
from MenuTool import MenuItem, manage_addMenuItem, manage_addMenuItemForm
from MenuTool import SubMenu, manage_addSubMenu, manage_addSubMenuForm
from MenuTool import MenuTool

# Rakun Relation Tool initialize
from RelationTool import RelationTool
from RelationTool import manage_addRelation1, manage_addRelation1Form, Relation1
from RelationTool import manage_addRelationN, manage_addRelationNForm, RelationN

rakun_globals = globals()
registerDirectory('skins',rakun_globals)
#registerModule('skins',rakun_globals)


this_module = sys.modules[ __name__ ]
tools = (DatabaseTool, ApplicationTool, MenuTool, RelationTool)
z_tool_bases = utils.initializeBasesPhase1(tools, this_module)

def initialize(registrar):
           
    registrar.registerClass(
        Interface,
        constructors = (manage_addInterfaceForm, manage_addInterface),
        icon = os.path.join('zmi','interface.gif')
        )
    
    # register fields
    registerFields()
    
    registrar.registerClass(
        Entity,
        constructors = (manage_addEntityForm, manage_addEntity),
        icon = os.path.join('zmi','entity.gif')
        )    
    
    Entity.settings_form._realize_fields()    
    Entity.message_settings._realize_fields()
    # register fields
    initializeFields(registrar)
    
    # Menu Objects register
    registrar.registerClass(
        MenuSeparator,
        constructors = (manage_addMenuSeparatorForm,manage_addMenuSeparator),
        icon = 'zmi/menu_separator.gif',
        visibility = None
        )
    
    registrar.registerClass(
        MenuItem,
        constructors = (manage_addMenuItemForm,manage_addMenuItem),
        icon = 'zmi/menu_item.gif',
        visibility = None
        )
    
    registrar.registerClass(
        SubMenu,
        constructors = (manage_addSubMenuForm,manage_addSubMenu),
        icon = 'zmi/submenu.gif',
        visibility = None
        )
    # Relation Object register
    registrar.registerClass(
        Relation1,
        constructors = (manage_addRelation1Form,manage_addRelation1),
        icon = 'zmi/relation.gif',
        visibility = None
        )
    registrar.registerClass(
        RelationN,
        constructors = (manage_addRelationNForm,manage_addRelationN),
        icon = 'zmi/relation.gif',
        visibility = None
        )
    # Rakun Tools initialize
    utils.initializeBasesPhase2(z_tool_bases, registrar)
    ToolInit( 'Rakun Tools'
              , tools=tools
              , product_name='Rakun'  
              , icon= 'tool.gif'  
              ).initialize(registrar)
   
