from Products.Rakun.Fields import BaseField
from Functions import Relation,Function


def typeoff(obj):
    if isinstance(obj, basestring):
        return 'string'
    elif isinstance(obj, int):
        return 'integer'
    elif isinstance(obj, float):
        return 'float'
    #...
  
  
class FieldRenderer:
  
    
    def field_render(self,field,value):   
        """
        """
        if isinstance(field, BaseField) and isinstance(value, BaseField):
            field = '%s.%s'%(field.getEntityName(), field.getName())
            value = '%s.%s'%(value.getEntityName(), value.getName())
            return (field, value)
        
        elif isinstance(field, BaseField) and isinstance(value, Function):
            field = '%s.%s'%(field.getEntityName(), field.getName())
            value = value.render()
            return (field, value)
        
        
        elif isinstance(field,BaseField):
            renderer = getattr(self,'%s_render'%field['type'],self.dummy_render)
            field = '%s.%s'%(field.getEntityName(),field.getName())
            value = renderer(value)
            return (field, value)
        
        elif isinstance(field,Relation):
            if isinstance(value,BaseField):
                value = '%s.%s'%(value.getEntityName(), value.getName())
            else:
                renderer = getattr(self,'%s_render'%field.field['type'],self.dummy_render)
                value = renderer(value)
            field = field.generateFieldName()
            return (field, value)
        
        elif isinstance(field,basestring) and isinstance(value, BaseField):
            value = '%s.%s'%(value.getEntityName(), value.getName())
            return (field, value)
            
        else:
            value_type = typeoff(value)
            renderer = getattr(self, '%s_render'%value_type,self.dummy_render)
            value = renderer(value)
            return (field, value)
  
    def string_render(self,value):
        """  """
        return "'%s'" %value
    
    def text_render(self,value):
        """  """
        return self.string_render(value)
    
    def date_render(self,value):
        """  """
        return self.string_render(value)
  
    def boolean_render(self,value):
        if value in [1,'1',True,'True']:
            return 'true'
        else:
            return 'false'
  
    def integer_render(self,value):
        if value is not None:
            return '%s'%value
        else:
            return 'null'
    
    def float_render(self,value):
        return self.integer_render(value)
  
    def money_render(self,value):
        return "'%s'" %value
    
    def dummy_render(self,value):
        return '%s'%value
    
